/*+
|                                               |
|     Trigger: DTULTATU_CORINTEPRO              |  
|     Tabela : CORINTEPRO                       |
|                                               |
|     Criao:                                  |
|     13/07/2007 - Danilo dos Anjos Faria       |
|                                               |
+*/


CREATE OR REPLACE TRIGGER DTULTATU_CORINTEPRO
BEFORE INSERT OR UPDATE OR DELETE
ON CORINTEPRO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCORINTE := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDPROSPECT,0) <> NVL(:NEW.CDPROSPECT,0)) OR
           (NVL(:OLD.CDINTEPROS,0) <> NVL(:NEW.CDINTEPROS,0)) OR
           (NVL(:OLD.CDTIPOCORR,0) <> NVL(:NEW.CDTIPOCORR,0)) THEN
         :NEW.DTULTATUCORINTE := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CORINTEPRO', ''         , 'CDPROSPECT='||:OLD.CDPROSPECT||';CDINTEPROS='||:OLD.CDINTEPROS||';CDTIPOCORR='||:OLD.CDTIPOCORR||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CORINTEPRO MODIFY DTULTATUCORINTE DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_CORINTEPRO','4.11.160'); END;
/

