IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_TPOPERCFOP' AND
                 TYPE   = 'TR' 		           AND
	              U.UID  = O.UID                AND
	              U.NAME = USER)
DROP TRIGGER LOG_TPOPERCFOP
GO

CREATE TRIGGER LOG_TPOPERCFOP
ON TPOPERCFOP
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_USUARIO      VARCHAR(40);
   DECLARE @V_TIPO         VARCHAR(1);
   DECLARE @V_ITPESQ       VARCHAR(40);
   DECLARE @V_DESC         VARCHAR(2000);    
   DECLARE @V_DTOPER       DATETIME;
   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);

/*VARIVEIS DO CURSOR C_CURSOR*/  
   DECLARE @V_ID_COMANDO         varchar(1);
   DECLARE @V_NEW_IDENTRSAIDOP   varchar(1);
   DECLARE @V_NEW_CDTIPOOPER     varchar(2);
   DECLARE @V_NEW_CDFISCOPER     varchar(4);
   DECLARE @V_NEW_IDATUESTTPCFOP varchar(1);
   DECLARE @V_NEW_IDCOMPOEVENC   varchar(1);

   DECLARE @V_OLD_IDENTRSAIDOP   varchar(1);
   DECLARE @V_OLD_CDTIPOOPER     varchar(2);
   DECLARE @V_OLD_CDFISCOPER     varchar(4);
   DECLARE @V_OLD_IDATUESTTPCFOP varchar(1);
   DECLARE @V_OLD_IDCOMPOEVENC   varchar(1);

BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';

   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;

   DECLARE C_CURSOR CURSOR FOR
      SELECT 'D' IDCOMANDO,
             IDENTRSAIDOP,
             CDTIPOOPER,
             CDFISCOPER,
             IDATUESTTPCFOP,
             IDCOMPOEVENC,

             NULL,
             NULL,
             NULL,
             NULL,
             NULL
        FROM DELETED
       WHERE
          IDENTRSAIDOP + CDTIPOOPER + CDFISCOPER NOT IN (SELECT IDENTRSAIDOP + CDTIPOOPER + CDFISCOPER FROM INSERTED)
       UNION ALL

      SELECT 'U' IDCOMANDO,
             DELETED.IDENTRSAIDOP,
             DELETED.CDTIPOOPER,
             DELETED.CDFISCOPER,
             DELETED.IDATUESTTPCFOP,
             DELETED.IDCOMPOEVENC,

             INSERTED.IDENTRSAIDOP,
             INSERTED.CDTIPOOPER,
             INSERTED.CDFISCOPER,
             INSERTED.IDATUESTTPCFOP,
             INSERTED.IDCOMPOEVENC
        FROM INSERTED, DELETED
       WHERE INSERTED.IDENTRSAIDOP = DELETED.IDENTRSAIDOP
         AND INSERTED.CDTIPOOPER   = DELETED.CDTIPOOPER
         AND INSERTED.CDFISCOPER   = DELETED.CDFISCOPER
       UNION ALL

      SELECT 'I' IDCOMANDO,
             NULL,
             NULL,
             NULL,
             NULL,
             NULL,

             IDENTRSAIDOP,
             CDTIPOOPER,
             CDFISCOPER,
             IDATUESTTPCFOP,
             IDCOMPOEVENC
        FROM INSERTED
       WHERE 
          IDENTRSAIDOP + CDTIPOOPER + CDFISCOPER NOT IN (SELECT IDENTRSAIDOP + CDTIPOOPER + CDFISCOPER FROM DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_NEW_IDENTRSAIDOP,@V_NEW_CDTIPOOPER,@V_NEW_CDFISCOPER,@V_NEW_IDATUESTTPCFOP,@V_NEW_IDCOMPOEVENC,
                                 
                                 @V_OLD_IDENTRSAIDOP,@V_OLD_CDTIPOOPER,@V_OLD_CDFISCOPER,@V_OLD_IDATUESTTPCFOP,@V_OLD_IDCOMPOEVENC;
      
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_OLD_IDENTRSAIDOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' E/S=' + @V_OLD_IDENTRSAIDOP;
         END;

         IF @V_OLD_CDTIPOOPER IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdTipoOPer=' + @V_OLD_CDTIPOOPER;
         END;

         IF @V_OLD_CDFISCOPER IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdFiscOper=' + @V_OLD_CDFISCOPER;
         END;

         IF @V_OLD_IDATUESTTPCFOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdAtuEstTpCfop=' + @V_OLD_IDATUESTTPCFOP;
         END;

         IF @V_OLD_IDCOMPOEVENC IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdCompoeVenc=' + @V_OLD_IDCOMPOEVENC;
         END;

         SET @V_TIPO   = '3';
         SET @V_ITPESQ = @V_OLD_IDENTRSAIDOP + @V_OLD_CDTIPOOPER + @V_OLD_CDFISCOPER;
      END ELSE 
      BEGIN
         IF @V_ID_COMANDO = 'U' BEGIN
            IF (ISNULL(@V_OLD_IDENTRSAIDOP,'!')   <> ISNULL(@V_OLD_IDENTRSAIDOP,'!'))   OR
               (ISNULL(@V_OLD_CDTIPOOPER,'!')     <> ISNULL(@V_OLD_CDTIPOOPER,'!'))     OR
               (ISNULL(@V_OLD_CDFISCOPER,'!')     <> ISNULL(@V_OLD_CDFISCOPER,'!'))     OR
               (ISNULL(@V_OLD_IDATUESTTPCFOP,'!') <> ISNULL(@V_OLD_IDATUESTTPCFOP,'!')) OR
               (ISNULL(@V_OLD_IDCOMPOEVENC, '!')  <> ISNULL(@V_OLD_IDCOMPOEVENC, '!'))  BEGIN

               SET @V_TIPO   = '2';
               SET @V_ITPESQ = @V_OLD_IDENTRSAIDOP+@V_OLD_CDTIPOOPER+@V_OLD_CDFISCOPER;
            END;
         END
         ELSE BEGIN
            SET @V_TIPO   = '1';
            SET @V_ITPESQ = @V_NEW_IDENTRSAIDOP+@V_NEW_CDTIPOOPER+@V_NEW_CDFISCOPER;
         END;
         
         IF ISNULL(@V_NEW_IDENTRSAIDOP, '!') <> ISNULL(@V_OLD_IDENTRSAIDOP, '!')     BEGIN
            SET @V_DESC = @V_DESC + ' E/S=' + @V_NEW_IDENTRSAIDOP;
         END;

         IF ISNULL(@V_NEW_CDTIPOOPER, '!') <> ISNULL(@V_OLD_CDTIPOOPER, '!')         BEGIN
            SET @V_DESC = @V_DESC + ' CdTipoOPer=' + @V_NEW_CDTIPOOPER;
         END;

         IF ISNULL(@V_NEW_CDFISCOPER, '!') <> ISNULL(@V_OLD_CDFISCOPER, '!')         BEGIN
            SET @V_DESC = @V_DESC + ' CdFiscOper=' + @V_NEW_CDFISCOPER;
         END;

         IF ISNULL(@V_NEW_IDATUESTTPCFOP, '!') <> ISNULL(@V_OLD_IDATUESTTPCFOP, '!') BEGIN
            SET @V_DESC = @V_DESC + ' IdAtuEstTpCfop=' + @V_NEW_IDATUESTTPCFOP;
         END;

         IF ISNULL(@V_NEW_IDCOMPOEVENC,'!') <> ISNULL(@V_OLD_IDCOMPOEVENC,'!')       BEGIN
            SET @V_DESC = @V_DESC + ' IdCompoeVenc=' + @V_NEW_IDCOMPOEVENC;
         END;

      END;
      
      IF @V_TIPO <> '0' BEGIN
         IF @V_DESC IS NOT NULL BEGIN
            EXEC NMUSUARIO  @V_USUARIO;
            SET @V_DTOPER = GETDATE();
            SET @V_DESC = SUBSTRING(@V_DESC, 1, 400);

            INSERT INTO LOGOPERA(NMTABELA,     DTOPERACAO,   NMRESPOPER,  IDTIPOOPER,   CDPESQITEM,  DSOPERACAO,
                                 DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES ('TPOPERCFOP', @V_DTOPER, @V_USUARIO, @V_TIPO, @V_ITPESQ, @V_DESC,
                    @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVERRDM, @V_DSSERVMETHOD, @V_DSREMOTEOPER);
         END;
      END;
      
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_NEW_IDENTRSAIDOP,@V_NEW_CDTIPOOPER,@V_NEW_CDFISCOPER,@V_NEW_IDATUESTTPCFOP,@V_NEW_IDCOMPOEVENC,
                                    
                                    @V_OLD_IDENTRSAIDOP,@V_OLD_CDTIPOOPER,@V_OLD_CDFISCOPER,@V_OLD_IDATUESTTPCFOP,@V_OLD_IDCOMPOEVENC;
      SET @V_DESC   = '';
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_TPOPERCFOP','5.75.xxx';
GO