var Fis00098_RelatorioCustomizavelContribuicoes_Controller = function(General, templateManager, ZhFilterPreferences, metaDataFactory) {
    
    this.vendasSATNFCe            = '1';
    this.vendasECF                = '2';
    this.registroEntradasPorItem  = '3';
    this.devolucaoComprasPorItem  = '4';
    this.devolucaoVendasPorItem   = '5';
    this.registroSaidasPorItemNFS = '6';
    
    this.preparaFiltroEFields = function(relatorioContribuicoes){
        this.setFieldsGerais(relatorioContribuicoes);
        var rowsToSet = {};
        rowsToSet.RELATORIO = "1";
        rowsToSet.REGIME = null;
        rowsToSet.IDTPEMISVEND = "T";
        ZhFilterPreferences.openFilterWidget(relatorioContribuicoes, rowsToSet);
    };
    
    this.setFieldsGerais = function(relatorioContribuicoes){
        templateManager.container.fieldsGerais = relatorioContribuicoes.fields.map(function(field){return field.name;});
    };
    
    this.preparaFiltroPorTipoRelatorio = function(filtro){
        var tipoRelatorio = filtro.currentRow.RELATORIO;
        var tipoOperacao = filtro.getField('NMTIPOOPER');
        
        if ([this.vendasSATNFCe, this.vendasECF].includes(tipoRelatorio)){
            tipoOperacao.readOnly = true;
            
        }else{
            tipoOperacao.readOnly = false;
            
        }
        
        if(this.vendasSATNFCe == tipoRelatorio){
            filtro.getField('IDTPEMISVEND').isVisible = true;
            filtro.getField('IDTPEMISVEND').class = '4';
            filtro.getField('NMTIPOOPER').class = '4';
            filtro.getField('CDFILIAL').class = '4';
        } else {
            filtro.getField('IDTPEMISVEND').isVisible = false;
            filtro.getField('NMTIPOOPER').class = '6';
            filtro.getField('CDFILIAL').class = '6';
        }
    };
    
    this.getTipoRelatorio = function(preference){
        var relatorioContribuicoes = templateManager.container.getWidget('relatorioContribuicoes');
        this.preparaWidgetPorTipoRelatorio(preference, relatorioContribuicoes);
    };
    
    this.preparaWidgetPorTipoRelatorio = function(preference, relatorioContribuicoes){
        var tipoRelatorio = preference.FILTER_ROW.RELATORIO;
        var widgetRelatorio = '';
        switch(tipoRelatorio){
            case this.vendasSATNFCe: 
                widgetRelatorio = templateManager.container.getWidget('vendasSATNFCe');
                break;
            case this.vendasECF: 
                widgetRelatorio = templateManager.container.getWidget('vendasECF');
                break;
            case this.registroEntradasPorItem: 
                widgetRelatorio = templateManager.container.getWidget('registroEntradasPorItem');
                break;
            case this.devolucaoComprasPorItem: 
                widgetRelatorio = templateManager.container.getWidget('devolucaoComprasPorItem');
                break;
            case this.devolucaoVendasPorItem: 
                widgetRelatorio = templateManager.container.getWidget('devolucaoVendasPorItem');
                break;
            case this.registroSaidasPorItemNFS: 
                widgetRelatorio = templateManager.container.getWidget('registroSaidasPorItemNFS');
                break;
        }
        this.setContribuicoesVendasSATNFCe(relatorioContribuicoes, widgetRelatorio);
    };
    
    this.setContribuicoesVendasSATNFCe = function(relatorioContribuicoes, widgetRelatorio){
        relatorioContribuicoes.label           = widgetRelatorio.label;
        templateManager.container.label           = widgetRelatorio.label;
        relatorioContribuicoes.dataSource.name      = widgetRelatorio.dataSource.name;
        relatorioContribuicoes.floatingControl.xlsAction.dataSourceName = widgetRelatorio.floatingControl.xlsAction.dataSourceName;
        var fieldsGerais = templateManager.container.fieldsGerais;
        var fieldsDelete = [];
        for (var i = 0; relatorioContribuicoes.fields.length > i; i++){
            if(!fieldsGerais.includes(relatorioContribuicoes.fields[i].name)){
                fieldsDelete.push(i);
            }
        }
        fieldsDelete.sort();
        for (var j = fieldsDelete.length - 1; j >= 0; j--){
            relatorioContribuicoes.fields.splice(fieldsDelete[j], 1);
        }

        widgetRelatorio.fields.forEach(function(field){
            relatorioContribuicoes.fields.push(field);
        });
        
        relatorioContribuicoes.redraw();
        
    };
    
    this.completaProduto = function(produto) {
        var mask = getLocalVar('CDPICTPROD');
        var length = 0;

        for (var i = mask.length - 1; i >= 0; i--) {
            if (mask[i] === '9' || mask[i] === '*') {
                length++;
            }
        }

        for (i = produto.length ; i < length ; i++) {
            produto += 'Z';
        }
        
        return produto;
    };

    this.preparaFiltroContribuicoes = function(widget, preference) {
        var produtoInicial = preference.FILTER_ROW.PRODUTOINI;
        var produtoFinal = this.completaProduto(preference.FILTER_ROW.PRODUTOFIN);
        var filial = preference.FILTER_ROW.CDFILIAL;
        widget.dataSourceFilter.forEach(function(filter){
            switch(filter.name){
                case 'CDFILIAL': filter.value = (Array.isArray(filial.value)) ? filial.value.toString().replace(/,/g, '_') : null;
                    break;
                case 'REGIME': filter.value = (preference.FILTER_ROW.REGIME) ? preference.FILTER_ROW.REGIME : null;
                    break;
                case 'CDIMPOSTO': filter.value = preference.FILTER_ROW.CDIMPOSTO;
                    break;
                case 'PRODUTOINI': filter.value = produtoInicial;
                    break;
                case 'PRODUTOFIN': filter.value = produtoFinal;
                    break;
                case 'DTINICIO': filter.value = preference.FILTER_ROW.DTINICIO.substr(0, 10);
                    break;
                case 'DTFINAL': filter.value = preference.FILTER_ROW.DTFINAL.substr(0, 10);
                    break;
            }
        });
     
        var dataSourceFilter = widget.dataSourceFilter;

     
        preference.CUSTOM_FILTER_ROW = Util.clone(preference.FILTER_ROW);
        var tipoRelatorio = preference.FILTER_ROW.RELATORIO;
        for (var t = dataSourceFilter.length - 1; t >= 0; t--) {
            if (dataSourceFilter[t].name === 'NMTIPOOPER') {
                dataSourceFilter.splice(t, 1);
            }
            if (dataSourceFilter[t].name === 'CDTIPOOPER') {
                dataSourceFilter.splice(t, 1);
            }
        }
        if ([this.vendasSATNFCe, this.vendasECF].includes(tipoRelatorio)){
            if (preference.CUSTOM_FILTER_ROW.hasOwnProperty('NMTIPOOPER')){
                delete preference.CUSTOM_FILTER_ROW.NMTIPOOPER;
            }
            if (preference.CUSTOM_FILTER_ROW.hasOwnProperty('CDTIPOOPER')){
                delete preference.CUSTOM_FILTER_ROW.CDTIPOOPER;
            }
        }else{
            dataSourceFilter.push(
                {
                    "name": "CDTIPOOPER",
                    "operator": "=",
                    "value": preference.FILTER_ROW.IDENTRSAIDOP + preference.FILTER_ROW.CDTIPOOPER
                }
            );
            preference.CUSTOM_FILTER_ROW.CDTIPOOPER = preference.FILTER_ROW.IDENTRSAIDOP + preference.FILTER_ROW.CDTIPOOPER;
        }
     
        if(this.vendasSATNFCe == tipoRelatorio){
            dataSourceFilter.push(
                {
                    "name": "IDTPEMISVEND",
                    "operator": "=",
                    "value": preference.FILTER_ROW.IDTPEMISVEND
                }
            );
            preference.CUSTOM_FILTER_ROW.IDTPEMISVEND = preference.FILTER_ROW.IDTPEMISVEND;
        } else { 
            if (preference.CUSTOM_FILTER_ROW.hasOwnProperty('IDTPEMISVEND')){
                delete preference.CUSTOM_FILTER_ROW.IDTPEMISVEND;
            }
            
            dataSourceFilter.forEach(function(filter, index){
                if(filter.name == 'IDTPEMISVEND'){
                    dataSourceFilter.splice(index, 1);
                }
            });
        }
        
        for (var i = dataSourceFilter.length - 1; i >= 0; i--) {
            if (dataSourceFilter[i].name === 'NRSEQUMAPAPU') {
                dataSourceFilter.splice(i, 1);
            }
            if (dataSourceFilter[i].name === 'RELATORIO') {
                dataSourceFilter.splice(i, 1);
            }
        }
        
        this.getTipoRelatorio(preference);
        
        if (preference.CUSTOM_FILTER_ROW.hasOwnProperty('NRSEQUMAPAPU')){
            delete preference.CUSTOM_FILTER_ROW.NRSEQUMAPAPU;
        }
        if (preference.CUSTOM_FILTER_ROW.hasOwnProperty('RELATORIO')){
            delete preference.CUSTOM_FILTER_ROW.RELATORIO;
        }
    };
    
    this.setValuesFilter = function(field, widget){
        field.dataSourceFilter.forEach(function(filter){
            switch(filter.name){
                case 'CDEMPRESA': filter.value = widget.currentRow.CDEMPRESA;
                    break;
                case 'CDIMPOSTO': filter.value = widget.currentRow.CDIMPOSTO;
                    break;
            }
        });
    };

    this.filterRules = function(widget) {
        var empresa = widget.currentRow.CDEMPRESA;
        var imposto = widget.currentRow.CDIMPOSTO;
        var fieldMapa = widget.getField('NMMAPAAPUR');
        
        if (empresa && imposto) {
            fieldMapa.readOnly = false;
            fieldMapa.value(null);
            this.setValuesFilter(fieldMapa, widget);
        } else {
            fieldMapa.readOnly = true;
            widget.currentRow.NMMAPAAPUR = null;
            widget.currentRow.NRSEQUMAPAPU = null;
            widget.currentRow.DTINIPERIODO = null;
            widget.currentRow.DTFIMPERIODO = null;    
        }
    };

    this.getCdnvproduto = function() {
        var levelMask = General.getLevelByMask('CDPICTPROD', 1);
        return levelMask.length;
    };

    this.setPlaceholder = function(widget) {
        var maxValue = this.getCdnvproduto;
        var field = widget.getField('NVTOT');
        field.placeholder = 'O nível máximo de totalização é ' . maxValue;
    };

    this.validaTotniv = function(widget) {
        var NVTOT = widget.currentRow.NVTOT;
        if (NVTOT > this.getCdnvproduto()) {
            widget.currentRow.NVTOT = null;
        }
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('Fis00098_RelatorioCustomizavelContribuicoes_Controller', Fis00098_RelatorioCustomizavelContribuicoes_Controller);
});